// single port sram module
`timescale 1ns / 10ps

module SRAM_1p (CLK, A, D, WEB, Q, CEB, OEB);

input        CLK, WEB, CEB, OEB;
input  [7:0] A; // Address bus
input  [7:0] D; // Data In
output [7:0] Q; // Data Out

reg [7:0] Q_n;

reg[7:0] SRAM_REG[255:0];
  
  //assign Q = (A == 8'hff) ? (Q_n & 8'hfe) : Q_n ;
  assign Q = Q_n;

  always @(posedge CLK) begin
  fork

  // Read operation 
  Q_n <= #2 (CEB == 1'b0 && OEB == 1'b0) ? SRAM_REG[A] : 8'bx;

  // Write operation 
  if (WEB == 1'b0 && CEB == 1'b0) begin
      SRAM_REG[A] <=#1 D;
  end
  join
  end

endmodule

